// based on the code from this post: https://usefulangle.com/post/81/javascript-change-url-parameters
(function () {
    "use strict";
    document.addEventListener('DOMContentLoaded', function () {
        var siteUrl = document.getElementById('site_url');
        var generatedUrl = document.getElementById('generated_url');
        var jsDynamicFilters = document.querySelectorAll('a.js_dynamic_filter');
        var clickHandler;
        var processUrlHandler;
        var allowedParams = ['session', 'room', 'jour', 'date'];
        var filterClicks = {};
        var old = {};
        var counter = {};

        // fonction de traitement de l'url en fonction des filtres recus
        processUrlHandler = function processUrlHandler(currentSiteUrl, doAfter) {
            var url;
            var searchParams;
            var newUrl;
            var k;
            var allParamValues;
            var newParam;
            var paramIndex;
            url = new URL(currentSiteUrl);
            searchParams = new URLSearchParams(url.search);
            // trier les paires cle/valeurs
            searchParams.sort();
            for (k of allowedParams) {
                if (false === searchParams.has(k)) {
                   continue;
                }
                allParamValues = searchParams.getAll(k);

                if (counter[k] === undefined) {
                    counter[k] = 0;
                    if ((allParamValues !== null) && (allParamValues !== undefined)) {
                        counter[k] = allParamValues.length;
                        old[k] = allParamValues;
                    }
                } else {
                    paramIndex = old[k].indexOf(searchParams.get(k));
                    newParam = old[k];
                    counter[k] = newParam.length;
                    // nouveau parametre donc ajouter
                    if (-1 === paramIndex) {
                        newParam.push(searchParams.get(k));
                        counter[k] = newParam.length;
                        searchParams.set(k, newParam.join());
                    } else { // existant dans la liste des parametres donc retirer de la liste
                        if (counter[k] > 1) {
                            newParam.splice(paramIndex, 1);
                            counter[k] = newParam.length;
                            searchParams.set(k, newParam.join());
                        } else if ((counter[k] === 1) && (filterClicks[currentSiteUrl] > 1)) {
                            searchParams.delete(k);
                            filterClicks[currentSiteUrl] = 0;
                            counter[k] = 0;
                            old[k] = [];
                        }
                    }
                    old[k] = newParam;
                }
            }
            console.table(counter);
            console.table(old);
            console.table(filterClicks);
            url.search = searchParams.toString();
            newUrl = url.toString();
            if (typeof doAfter === 'function') {
                doAfter(newUrl);
            }
        };
        // a chaque changement de l'url du site
        clickHandler = function (evt) {
            evt.preventDefault();
            evt.stopPropagation();
            siteUrl.value = (evt.currentTarget.href || '');
            if (filterClicks[evt.currentTarget.href] === undefined) {
                filterClicks[evt.currentTarget.href] = 0;
            }
            filterClicks[evt.currentTarget.href]++;
            // traiter les filtres et modifier l'url generée
            processUrlHandler(siteUrl.value, function (result) {
                generatedUrl.value = result;
            });
        };
        jsDynamicFilters.forEach(function (element) {
            element.addEventListener('click', clickHandler);
        });
    });
}());
